# rtsp onvif media

a GstRTSPOnvifMedia contains the complete GStreamer pipeline to manage the streaming to the clients. The actual data transfer is done by the GstRTSPStream objects that are created and exposed by the GstRTSPMedia.

On top of GstRTSPMedia this subclass adds special ONVIF features. Special ONVIF features that are currently supported is a backchannel for the client to send back media to the server in a normal PLAY media. To handle the ONVIF backchannel, a GstRTSPOnvifMediaFactory and GstRTSPOnvifServer has to be used.

## GstRTSPOnvifMedia

    GObject
        ╰──GstRTSPMedia
            ╰──GstRTSPOnvifMedia

### Members

`parent` (GstRTSPMedia) –
No description available
`priv` (GstRTSPOnvifMediaPrivate*) –
No description available

Since : 1.14

### Class structure

#### GstRTSPOnvifMediaClass

##### Fields

`parent` (GstRTSPMediaClass) –
No description available

### GstRtspServer.RTSPOnvifMediaClass

##### Attributes

`parent` (GstRtspServer.RTSPMediaClass) –
No description available

### GstRtspServer.RTSPOnvifMediaClass

##### Attributes

`parent` (GstRtspServer.RTSPMediaClass) –
No description available

## GstRtspServer.RTSPOnvifMedia

    GObject.Object
        ╰──GstRtspServer.RTSPMedia
            ╰──GstRtspServer.RTSPOnvifMedia

### Members

`parent` (GstRtspServer.RTSPMedia) –
No description available
`priv` (GstRtspServer.RTSPOnvifMediaPrivate) –
No description available

Since : 1.14

## GstRtspServer.RTSPOnvifMedia

    GObject.Object
        ╰──GstRtspServer.RTSPMedia
            ╰──GstRtspServer.RTSPOnvifMedia

### Members

`parent` (GstRtspServer.RTSPMedia) –
No description available
`priv` (GstRtspServer.RTSPOnvifMediaPrivate) –
No description available

Since : 1.14

### Methods

#### gst_rtsp_onvif_media_collect_backchannel

    gboolean
    gst_rtsp_onvif_media_collect_backchannel (GstRTSPOnvifMedia * media)

Find the ONVIF backchannel depayloader element. It should be named 'depay_backchannel', be placed in a bin called 'onvif-backchannel' and return all supported RTP caps on a caps query. Complete RTP caps with at least the payload type, clock-rate and encoding-name are required.

A new GstRTSPStream is created for the backchannel if found.

Parameters:

`media` –

a GstRTSPOnvifMedia

Returns –

TRUE if a backchannel stream could be found and created

Since : 1.14

#### GstRtspServer.RTSPOnvifMedia.prototype.collect_backchannel

    function GstRtspServer.RTSPOnvifMedia.prototype.collect_backchannel(): {
        // javascript wrapper for 'gst_rtsp_onvif_media_collect_backchannel'
    }

Find the ONVIF backchannel depayloader element. It should be named 'depay_backchannel', be placed in a bin called 'onvif-backchannel' and return all supported RTP caps on a caps query. Complete RTP caps with at least the payload type, clock-rate and encoding-name are required.

A new GstRtspServer.RTSPStream is created for the backchannel if found.

Parameters:

`media` (GstRtspServer.RTSPOnvifMedia) –

a GstRtspServer.RTSPOnvifMedia

Returns (Number) –

true if a backchannel stream could be found and created

Since : 1.14

#### GstRtspServer.RTSPOnvifMedia.collect_backchannel

    def GstRtspServer.RTSPOnvifMedia.collect_backchannel (self):
        #python wrapper for 'gst_rtsp_onvif_media_collect_backchannel'

Find the ONVIF backchannel depayloader element. It should be named 'depay_backchannel', be placed in a bin called 'onvif-backchannel' and return all supported RTP caps on a caps query. Complete RTP caps with at least the payload type, clock-rate and encoding-name are required.

A new GstRtspServer.RTSPStream is created for the backchannel if found.

Parameters:

`media` (GstRtspServer.RTSPOnvifMedia) –

a GstRtspServer.RTSPOnvifMedia

Returns (bool) –

True if a backchannel stream could be found and created

Since : 1.14

#### gst_rtsp_onvif_media_get_backchannel_bandwidth

    guint
    gst_rtsp_onvif_media_get_backchannel_bandwidth (GstRTSPOnvifMedia * media)

Get the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

Parameters:

`media` –

a GstRTSPMedia

Returns –

the configured/supported backchannel bandwidth.

Since : 1.14

#### GstRtspServer.RTSPOnvifMedia.prototype.get_backchannel_bandwidth

    function GstRtspServer.RTSPOnvifMedia.prototype.get_backchannel_bandwidth(): {
        // javascript wrapper for 'gst_rtsp_onvif_media_get_backchannel_bandwidth'
    }

Get the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

Parameters:

`media` (GstRtspServer.RTSPOnvifMedia) –

a GstRtspServer.RTSPMedia

Returns (Number) –

the configured/supported backchannel bandwidth.

Since : 1.14

#### GstRtspServer.RTSPOnvifMedia.get_backchannel_bandwidth

    def GstRtspServer.RTSPOnvifMedia.get_backchannel_bandwidth (self):
        #python wrapper for 'gst_rtsp_onvif_media_get_backchannel_bandwidth'

Get the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

Parameters:

`media` (GstRtspServer.RTSPOnvifMedia) –

a GstRtspServer.RTSPMedia

Returns (int) –

the configured/supported backchannel bandwidth.

Since : 1.14

#### gst_rtsp_onvif_media_set_backchannel_bandwidth

    gst_rtsp_onvif_media_set_backchannel_bandwidth (GstRTSPOnvifMedia * media,
                                                    guint bandwidth)

Set the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

Parameters:

`media` –

a GstRTSPMedia

`bandwidth` –

the bandwidth in bits per second

Since : 1.14

#### GstRtspServer.RTSPOnvifMedia.prototype.set_backchannel_bandwidth

    function GstRtspServer.RTSPOnvifMedia.prototype.set_backchannel_bandwidth(bandwidth: Number): {
        // javascript wrapper for 'gst_rtsp_onvif_media_set_backchannel_bandwidth'
    }

Set the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

Parameters:

`media` (GstRtspServer.RTSPOnvifMedia) –

a GstRtspServer.RTSPMedia

`bandwidth` (Number) –

the bandwidth in bits per second

Since : 1.14

#### GstRtspServer.RTSPOnvifMedia.set_backchannel_bandwidth

    def GstRtspServer.RTSPOnvifMedia.set_backchannel_bandwidth (self, bandwidth):
        #python wrapper for 'gst_rtsp_onvif_media_set_backchannel_bandwidth'

Set the configured/supported bandwidth of the ONVIF backchannel pipeline in bits per second.

Parameters:

`media` (GstRtspServer.RTSPOnvifMedia) –

a GstRtspServer.RTSPMedia

`bandwidth` (int) –

the bandwidth in bits per second

Since : 1.14

## Function Macros

### GST_RTSP_ONVIF_MEDIA_CAST

    #define GST_RTSP_ONVIF_MEDIA_CAST(obj)         ((GstRTSPOnvifMedia*)(obj))

### GST_RTSP_ONVIF_MEDIA_CLASS_CAST

    #define GST_RTSP_ONVIF_MEDIA_CLASS_CAST(klass) ((GstRTSPOnvifMediaClass*)(klass))

The results of the search are